<?php session_start();
date_default_timezone_set('America/Bogota');
//RESTRICCI�N DE ACCESO A TRABAJADOR (ACCESO INDIVIDUAL)
if (isset($_SESSION['tipousuario']))
		{if ($_SESSION['tipousuario']=='1')
		header ('location:menu_personal.php');
		}
if  (trim($_SESSION['nombre_validar'])=='') header ('location:index.php');
include ("fphp.php");
$enlace=cargar_conexion();

		/////Genera TXt nomina Diariadssssssssssss
		
		//////Consulto el periodo (lote) más reciente de cestaticket procesado 
		////--- El TXT siempre será generado del último lote de Cesataticket procesado
		$query_max_fecha_regist = "SELECT MAX(fecha_registro) AS fecha_registro FROM historico_cestaticket WHERE id='".$_SESSION['id_validar']."'";
		$query_max_fecha_regist=mysqli_query($enlace,$query_max_fecha_regist) or die ($query_max_fecha_regist.mysqli_error($enlace));
		$rowfecha = mysqli_fetch_array($query_max_fecha_regist);
		$max_fecha=$rowfecha['fecha_registro'];
		
		

if ($_SESSION['id_validar']==104 ){
	
	////Inicia BNC para empleados con cuenta de BNC
				
				$consultaEmpresa="select nombre,encabeza from empresa where id='".$_SESSION['id_validar']."' ";
				$consultaEmpresa=mysqli_query($enlace,$consultaEmpresa) or die ($consultaEmpresa.mysqli_error($enlace));
				$rowEmpresa = mysqli_fetch_array($consultaEmpresa);
				$nombreEmpresa = $rowEmpresa['nombre'];
				$rifEmpresa   = $rowEmpresa['encabeza'];
				$rifEmpresa = preg_replace('([^A-Za-z0-9])', '', $rifEmpresa);

			
				$query_emp_pagar = "SELECT pct.*, CONCAT (pe.nombres, ' ', pe.apellidos) as nombres, pe.cuenta, pe.mensaje, pe.nacionalidad FROM historico_cestaticket AS pct INNER JOIN personal AS pe ON pct.cedula = pe.codigo WHERE pct.id = '".$_SESSION['id_validar']."'  AND pe.banco='0191' AND pct.fecha_registro = '".$max_fecha."' order by pct.cedula";

					$resul_emp_pagar = mysqli_query($enlace,$query_emp_pagar);
					$cant_emp_pagar = mysqli_num_rows($resul_emp_pagar);


					//Consulta monto total a pagar
					$query_monto_pagar = "SELECT SUM(pct.monto) AS monto , pct.cedula, pe.codigo
					FROM historico_cestaticket as pct
					INNER JOIN personal AS pe ON pct.cedula = pe.codigo 
					WHERE pct.fecha_registro = '".$max_fecha."' AND pe.banco='0191' AND pct.id='".$_SESSION['id_validar']."'";
					$resul_monto_pagar = mysqli_query($enlace,$query_monto_pagar);
					$row_monto=mysqli_fetch_array($resul_monto_pagar);
					$monto_total_pagar = str_replace('.','',$row_monto['monto']); //Monto total a pagar, se le quita el signo punto

					$fecha_lote = date("dmY-His"); //Fecha a imprimir en archivo (Fecha sin ceros a la izquierda)
					$numero_lote_archivo = rand(1000000,9999999); //Número aleatorio
					$numero_serie = rand(100000,999999)+100000;

					//Generación de archivo
					$filename = "pago_cestaticket_bnc-".$fecha_lote.".txt";
					$f = "pagoespecial_txt/".$filename;
					$file = fopen($f,"w+");
					
					fwrite($file, "ND");
					fwrite($file, " ");
					fwrite($file, "01910085532185049069");
					fwrite($file, str_repeat("0",13-strlen($monto_total_pagar)));
					fwrite($file, $monto_total_pagar);
					fwrite($file, $rifEmpresa);
					fwrite($file, "\r\n"); //Nueva Linea
			
				while ($row_emp_pag=mysqli_fetch_array($resul_emp_pagar)){
						$cedula = $row_emp_pag['cedula'];
						$monto = str_replace('.','',$row_emp_pag['monto']); //Monto total a pagar, se le quita el signo punto
						$concepto_monto = $row_emp_pag['concepto'];
						$cuenta_banco = $row_emp_pag['cuenta'];
						$nacionalidad = $row_emp_pag['nacionalidad'];
						$nombres = preg_replace("/\s+/", " ", trim($row_emp_pag['nombres']));
						$correo = $row_emp_pag['mensaje'];

						fwrite($file, "NC");
						fwrite($file, " ");
						fwrite($file,str_pad($cuenta_banco, 20, "0", STR_PAD_LEFT)); //Número de cuenta
						fwrite($file, str_pad($monto, 13, "0", STR_PAD_LEFT));
						fwrite($file, $nacionalidad);
						fwrite($file, str_pad($cedula, 9, "0", STR_PAD_LEFT));
						fwrite($file,"\r\n"); //Nueva Linea
					
					}
					fclose($file);

					echo "<style>
						.regristrado{
								color: green;
								margin-left: 7%;
								font-weight: bold;
						}
					</style>";
					echo "<p class='regristrado' >Archivo BNC guardado correctamente <a href = 'generar_txt.php?specialPayment=$filename&directory=pagoespecial_txt';>Descargar</a><p>";
					
				//// Fin BNC
				
				//// inicia Provincial para empelados que no tienen cuenta en BNC
		//Consulta empleados a pagar
		
		$query_emp_pagar = "SELECT pct.*, CONCAT (pe.nombres, ' ', pe.apellidos) as nombres, pe.cuenta, pe.tipo, pe.mensaje, pe.nacionalidad, pe.nomina 
		FROM historico_cestaticket AS pct 
		INNER JOIN personal AS pe ON pct.cedula = pe.codigo 
		WHERE pct.id = '".$_SESSION['id_validar']."' AND pe.banco!='0191' AND pct.cedula = pe.codigo AND pct.fecha_registro='".$max_fecha."' AND pct.concepto = '3102'  AND estado_aprobacion_1='Por aprobar'  AND envio_banesco='No' 
		GROUP BY pct.cedula order by pct.cedula";

	 	$resul_emp_pagar = mysqli_query($enlace,$query_emp_pagar);
		$cant_emp_pagar = mysqli_num_rows($resul_emp_pagar);


		//Consulta monto total a pagar
		$query_monto_pagar = "SELECT SUM(monto) AS monto FROM historico_cestaticket WHERE concepto = '3102' AND id='".$_SESSION['id_validar']."' AND estado_aprobacion_1='Por aprobar' AND envio_banesco='No' AND fecha_registro='".$max_fecha."'";
	 	$resul_monto_pagar = mysqli_query($enlace,$query_monto_pagar);
		$row_monto=mysqli_fetch_array($resul_monto_pagar);
		$monto_total_pagar = str_replace('.','',$row_monto['monto']); //Monto total a pagar, se le quita el signo punto

		$fecha_lote = date("dmYhis"); //Fecha a imprimir en archivo (Fecha sin ceros a la izquierda)
		$fecha_pago = date("dmY");
		$numero_lote_archivo = rand(1000000,9999999); //Número aleatorio
		$numero_serie = rand(100000,999999)+100000;

//Generación de archivo
			$filename_ot = "pago_cesaticket_otros_bancos-".$fecha_lote.".txt";
					$fo = "pagoespecial_txt/".$filename_ot;
					$file_ot = fopen($fo,"w+");
					
		while ($row_emp_pag=mysqli_fetch_array($resul_emp_pagar)){
			$cedula = $row_emp_pag['cedula'];
			$monto = str_replace('.','',$row_emp_pag['monto']); //Monto total a pagar, se le quita el signo punto
			$concepto_monto = $row_emp_pag['concepto'];
			$cuenta_banco = $row_emp_pag['cuenta'];
			$nacionalidad = $row_emp_pag['nacionalidad'];
			$nombres = preg_replace("/\s+/", " ", trim($row_emp_pag['nombres']));
			$correo = $row_emp_pag['mensaje'];
			$nomina = $row_emp_pag['nomina'];

			//fwrite($file,"2V"); //Constante

			//fwrite($file,"1000000000000               000000000000000"); //Constante
			fwrite($file_ot,str_pad($cuenta_banco, 20, "0", STR_PAD_LEFT)); //Número de cuenta
			fwrite($file_ot," ");//Constante
			fwrite($file_ot,$nacionalidad);
			fwrite($file_ot,str_pad($cedula, 10, "0", STR_PAD_LEFT)); //Número de cedula
			fwrite($file_ot," ");//Constante
			fwrite($file_ot,str_pad($monto, 15, "0", STR_PAD_LEFT)); //Monto a pagar
			fwrite($file_ot," ");//Constante
			fwrite($file_ot,str_pad($nombres, 35, " ", STR_PAD_RIGHT)); //Imprime nombres con espacios hasta 35 caracteres
			
			fwrite($file_ot,"\r\n"); //Nueva Linea

		}
    fclose($file_ot);
	echo "<style>
						.regristrado{
								color: green;
								margin-left: 7%;
								font-weight: bold;
						}
					</style>";
					echo "<p class='regristrado' >Archivo Provicinal Otros bancos guardado correctamente <a href = 'generar_txt.php?specialPayment=$filename_ot&directory=pagoespecial_txt';>Descargar</a><p>";
	
	//////Fin Provincial a otros bancos
	/////Finaliza para MERSAN
	}	elseif ($_SESSION['id_validar']==105 ){ //// Inicia para FINTECH
		$consultaEmpresa="select nombre from empresa where id='".$_SESSION['id_validar']."' ";
		$consultaEmpresa=mysqli_query($enlace,$consultaEmpresa) or die ($consultaEmpresa.mysqli_error($enlace));
		$rowEmpresa = mysqli_fetch_array($consultaEmpresa);
		$nombreEmpresa=$rowEmpresa['nombre'];
		////////////////**************************************

		$fecha_pago = date('d/m/y');
		$nombre_archivo = "bancos.txt";
		//$file = fopen($nombre_archivo, "w+");
		fwrite($file, "H");
		fwrite($file, $nombreEmpresa);
		fwrite($file, str_repeat(" ",40-strlen($nombreEmpresa)));
		fwrite($file, "01020759250000054933");
		fwrite($file, "08");
		fwrite($file, $fecha_pago);
		fwrite($file, str_repeat("0",13-strlen($monto_total_pagar)));
		fwrite($file, $monto_total_pagar);
		fwrite($file, "03291");
		fwrite($file, " ");

		fwrite($file, "\r\n");
				//REGISTRO: SEGUNDA LINEA //

				while ($row_emp_pag=mysqli_fetch_array($resul_emp_pagar)){
					$cedula = $row_emp_pag['cedula'];
					$monto = str_replace('.','',$row_emp_pag['monto']); //Monto total a pagar, se le quita el signo punto
					$concepto_monto = $row_emp_pag['concepto'];
					$cuenta_banco = $row_emp_pag['cuenta'];
					$tipo_cuenta = $row_emp_pag['tipo'];
					$tipo_cuenta = $tipo_cuenta - 1 ; ////para coincidir con el tipo en el txt ahorros=0, corriente = 1 Miguelangel
					$nacionalidad = $row_emp_pag['nacionalidad'];
					$nombres = preg_replace("/\s+/", " ", trim($row_emp_pag['nombres']));
					$correo = $row_emp_pag['mensaje'];
					$nomina = $row_emp_pag['nomina'];

					//fwrite($file,"2V"); //Constante

					//fwrite($file,"1000000000000               000000000000000"); //Constante
					fwrite($file,$tipo_cuenta);
					fwrite($file,str_pad($cuenta_banco, 20, "0", STR_PAD_LEFT)); //Número de cuenta
					fwrite($file, str_pad($monto, 11, "0", STR_PAD_LEFT));
					fwrite($file,$tipo_cuenta);
					fwrite($file, "770");
					fwrite($file,str_pad($nombres, 40, " ", STR_PAD_RIGHT));
					fwrite($file,str_pad($cedula, 10, "0", STR_PAD_LEFT)); //Número de cedula
					fwrite($file, "003291");
					fwrite($file, "  ");

					fwrite($file,"\r\n"); //Nueva Linea

				}

		    fclose($file);
		    //fclose($fileOtros);
				}
    echo "<style>
    .regristrado{
        color: green;
        margin-left: 7%;
        font-weight: bold;
    }
    </style>";
    echo "<p class='regristrado' >Archivos guardados correctamente<p>";
    echo "<script> window.location.href = 'generar_txt.php?file=$f'; </script>";




?>
